# Configure paths for Gaim
# Owen Taylor     1997-2001
# Modified from AM_PATH_GTK_2_0 by Levi Bard, 2005

dnl AM_PATH_GAIM([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND [, MODULES]]]])
dnl Test for Gaim, and define GAIM_CFLAGS and GAIM_LIBS
dnl
AC_DEFUN([AM_PATH_GAIM],
[dnl 
dnl Get the cflags and libraries from pkg-config
dnl
dnl AC_ARG_ENABLE(gtktest, [  --disable-gtktest       do not try to compile and run a test GTK+ program],
dnl		    , enable_gtktest=yes)

  pkg_config_args=gaim
dnl  for module in . $4
dnl  do
dnl      case "$module" in
dnl         gthread) 
dnl             pkg_config_args="$pkg_config_args gthread-2.0"
dnl         ;;
dnl      esac
dnl  done

  no_gaim=""

  AC_PATH_PROG(PKG_CONFIG, pkg-config, no)

  if test x$PKG_CONFIG != xno ; then
    if pkg-config --atleast-pkgconfig-version 0.7 ; then
      :
    else
      echo "*** pkg-config too old; version 0.7 or better required."
      no_gaim=yes
      PKG_CONFIG=no
    fi
  else
    no_gaim=yes
  fi

  min_gaim_version=ifelse([$1], ,1.0.0,$1)
  AC_MSG_CHECKING(for Gaim - version >= $min_gaim_version)

  if test x$PKG_CONFIG != xno ; then
    ## don't try to run the test against uninstalled libtool libs
    if $PKG_CONFIG --uninstalled $pkg_config_args; then
	  echo "Will use uninstalled version of Gaim found in PKG_CONFIG_PATH"
	  dnl enable_gaimtest=no
    fi

    if $PKG_CONFIG --atleast-version $min_gaim_version $pkg_config_args; then
	  :
    else
	  no_gaim=yes
    fi
  fi

  if test x"$no_gaim" = x ; then
    GAIM_CFLAGS=`$PKG_CONFIG $pkg_config_args --cflags`
    GAIM_LIBS=`$PKG_CONFIG $pkg_config_args --libs`
dnl    gaim_config_major_version=`$PKG_CONFIG --modversion gaim | \
dnl           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/' | \
dnl		   sed 's/[^0-9]*//'`
dnl    gaim_config_minor_version=`$PKG_CONFIG --modversion gaim | \
dnl           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/' | \
dnl		   sed 's/[^0-9]*//'`
	gaim_config_major_version=`$PKG_CONFIG --modversion gaim | \
		sed 's/\..*//'`
		dnl echo $gaim_config_major_version
	gaim_config_minor_version=`$PKG_CONFIG --modversion gaim | \
		sed 's/[^\.]*\.//' | sed 's/\..*//'`
		dnl echo $gaim_config_minor_version
    gaim_config_micro_version=`$PKG_CONFIG --modversion gaim | \
		sed 's/.*\.//'`
		dnl echo $gaim_config_micro_version
           dnl sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
  fi
	
dnl
dnl Now check if the installed Gaim is sufficiently new. (Also sanity
dnl checks the results of pkg-config to some extent)
dnl

  if test "x$no_gaim" = x ; then
     AC_MSG_RESULT(yes (version $gaim_config_major_version.$gaim_config_minor_version.$gaim_config_micro_version))
     ifelse([$2], , :, [$2])     
  else
     AC_MSG_RESULT(no)
     if test "$PKG_CONFIG" = "no" ; then
       echo "*** A new enough version of pkg-config was not found."
       echo "*** See http://pkgconfig.sourceforge.net"
     fi
     GTK_CFLAGS=""
     GTK_LIBS=""
     ifelse([$3], , :, [$3])
  fi
  AC_SUBST(GAIM_CFLAGS)
  AC_SUBST(GAIM_LIBS)
])
