#ifndef IGNORANCE_H
#define IGNORANCE_H

#include "ignorance_level.h"

#define IGNORANCE_APPLY_CHAT	1
#define IGNORANCE_APPLY_IM		2
#define IGNORANCE_APPLY_USER	4
#define IGNORANCE_APPLY_HOST	8
#define IGNORANCE_APPLY_ENTERLEAVE 16
#define IGNORANCE_APPLY_INVITE	32


//returns the level with a given name, or NULL
ignorance_level*	ignorance_get_level_name(const GString *levelname);

//adds a level to the list
gboolean ignorance_add_level(ignorance_level *level);

//removes a group from the list
gboolean ignorance_remove_level(const GString *levelname);

//get a valid level index for a new level
gint ignorance_get_new_level_index();

// saves your levels, rules, and denizens to
// ~/.gaim/ignorance
gboolean save_conf();


#endif
